<script setup>
import BreezeAuthenticatedLayout from '@/Layouts/Authenticated.vue'
import {Link, Head, useForm, router} from '@inertiajs/vue3'

const props = defineProps({
    account: {
        type: Object,
        required: true
    },
    users: {
        type: Array,
        required: true
    }
})

const form = useForm({...props.account, owner_id:props.account.owner_id}) // placeholder value

const update = () => {
    form.put(route('accounts.update', form.id), {
        onSuccess: () => form.reset()
    })
}

const deleteRow = (id) => {
    if (window.confirm("Delete account?")) {
        router.delete(route('accounts.destroy', id), {
            preserveScroll: true
        })
    }
}
</script>

<template>
    <Head :title="'Edit - ' + account.name" />

    <BreezeAuthenticatedLayout>
        <div class="max-w-screen-lg mx-auto my-6 space-y-6">
            <div class="bg-white shadow px-4 py-5 sm:rounded-lg sm:p-6">
                <div class="md:grid md:grid-cols-3 md:gap-6">
                    <div class="md:col-span-1">
                        <h3 class="text-lg font-medium leading-6 text-gray-900">Account Information</h3>
                        <ul class="mt-6">
                            <li class="text-red-500" v-for="error in form.errors">{{ error }}</li>
                        </ul>
                    </div>
                    <div class="mt-5 md:mt-0 md:col-span-2">
                        <form @submit.prevent="update">
                            <div class="grid grid-cols-6 gap-6">
                                <div class="col-span-6 sm:col-span-3">
                                    <label for="name" class="block text-sm font-medium"
                                    :class="{ 'text-gray-700': !form.errors.name, 'text-red-700': form.errors.name }">Name</label>
                                    <input
                                        type="text"
                                        id="name"
                                        name = "name"
                                        v-model="form.name"
                                        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm border-gray-300 rounded-md"
                                    >
                                    <div class="font-sm text-red-500 mt-2" v-if="form.errors.name">{{ form.errors.name }}</div>
                                </div>

                                <div class="col-span-6 sm:col-span-3">
                                    <label for="owner_id" class="block text-sm font-medium"
                                    :class="{ 'text-gray-700': !form.errors.owner_id, 'text-red-700': form.errors.owner_id }">Owner</label>
                                    <select
                                        id="owner_id"
                                        name = "owner_id"
                                        v-model="form.owner_id"
                                        class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:sm:text-sm"
                                        :class="{ 'bg-red border-red-300 text-red-700': form.errors.owner_id, 'border-gray-300 bg-white': !form.errors.owner_id}"
                                    >
                                        <option value="">Select owner</option>
                                        <option v-for="user in users" :key="user.id" :value="user.id">{{ user.name }}</option>
                                    </select>
                                    <div class="font-sm text-red-500 mt-2" v-if="form.errors.owner_id">{{ form.errors.owner_id }}</div>
                                </div>

                                <div class="col-span-6 sm:col-span-3">
                                    <label for="phone" class="block text-sm font-medium"
                                    :class="{ 'text-gray-700': !form.errors.phone, 'text-red-700': form.errors.phone }">Phone</label>
                                    <input
                                        type="tel"
                                        id="phone"
                                        name = "phone"
                                        v-model="form.phone"
                                        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm rounded-md"
                                        :class="{ 'bg-red-50 border-red-500 text-red-700': form.errors.phone, 'border-gray-300': !form.errors.phone}"
                                    >
                                    <div class="font-sm text-red-500 mt-2" v-if="form.errors.phone">{{ form.errors.phone }}</div>
                                </div>

                                <div class="col-span-6 sm:col-span-3">
                                    <label for="country" class="block text-sm font-medium"
                                    :class="{ 'text-gray-700': !form.errors.country, 'text-red-700': form.errors.country }">Country</label>
                                    <input
                                        type="text"
                                        id="country"
                                        name = "country"
                                        v-model="form.country"
                                        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm rounded-md"
                                        :class="{ 'bg-red-50 border-red-500 text-red-700': form.errors.country, 'border-gray-300': !form.errors.country}"
                                    >
                                    <div class="font-sm text-red-500 mt-2" v-if="form.errors.country">{{ form.errors.country }}</div>
                                </div>

                                <div class="col-span-6">
                                    <label for="address" class="block text-sm font-medium"
                                    :class="{ 'text-gray-700': !form.errors.address, 'text-red-700': form.errors.address }">Address</label>
                                    <input
                                        type="text"
                                        id="address"
                                        name = "address"
                                        v-model="form.address"
                                        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm rounded-md"
                                        :class="{ 'bg-red-50 border-red-500 text-red-700': form.errors.address, 'border-gray-300': !form.errors.address}"
                                    >
                                    <div class="font-sm text-red-500 mt-2" v-if="form.errors.address">{{ form.errors.address }}</div>
                                </div>

                                <div class="col-span-6 sm:col-span-6 lg:col-span-2">
                                    <label for="town_city" class="block text-sm font-medium"
                                    :class="{ 'text-gray-700': !form.errors.town_city, 'text-red-700': form.errors.town_city }">Town/City</label>
                                    <input
                                        type="text"
                                        id="town_city"
                                        name = "town_city"
                                        v-model="form.town_city"
                                        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm rounded-md"
                                        :class="{ 'bg-red-50 border-red-500 text-red-700': form.errors.town_city, 'border-gray-300': !form.errors.town_city}"
                                    >
                                    <div class="font-sm text-red-500 mt-2" v-if="form.errors.town_city">{{ form.errors.town_city }}</div>
                                </div>

                                <div class="col-span-6 sm:col-span-3 lg:col-span-2">
                                    <label for="post_code" class="block text-sm font-medium"
                                    :class="{ 'text-gray-700': !form.errors.post_code, 'text-red-700': form.errors.post_code }">Post code</label>
                                    <input
                                        type="text"
                                        id="post_code"
                                        name = "post_code"
                                        v-model="form.post_code"
                                        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm rounded-md"
                                        :class="{ 'bg-red-50 border-red-500 text-red-700': form.errors.post_code, 'border-gray-300': !form.errors.post_code}"
                                    >
                                    <div class="font-sm text-red-500 mt-2" v-if="form.errors.post_code">{{ form.errors.post_code }}</div>
                                </div>
                            </div>
                            <div class="flex justify-between mt-6">
                                <button
                                    type="button"
                                    @click.prevent="deleteRow(props.account.id)"
                                    class="inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-red-600 hover:bg-red-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-red-500"
                                >
                                    Delete
                                </button>
                                <div>
                                    <Link :href="route('accounts.index')" class="bg-white py-2 px-4 border border-gray-300 rounded-md shadow-sm text-sm font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">Cancel</Link>
                                    <button type="submit" class="ml-3 inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">Save</button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </BreezeAuthenticatedLayout>
</template>